var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "event-mailer-config.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);

/**
*
*  UTF-8 data encode / decode
*  http://www.webtoolkit.info/
*
**/
 
var Utf8 = {
 
    // public method for url encoding
    encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
 
        for (var n = 0; n < string.length; n++) {
 
            var c = string.charCodeAt(n);
 
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
 
        }
 
        return utftext;
    },
 
    // public method for url decoding
    decode : function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;
 
        while ( i < utftext.length ) {
 
            c = utftext.charCodeAt(i);
 
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
 
        }
 
        return string;
    }
 
}

function storeSubParameter(path,value)
{
	Property.setProperty('values/' + path, value);
	Property.setFlag('values/' + path, 'ARCHIVE', true);
}

function storeValue(sParameterString)
{
	var oParameterObject=JSON.parse(unescape(sParameterString));
	var idValue=oParameterObject.id;
	if (idValue==null)
	{
		idValue=1;
		var oParameterBase=Property.getNode("values");
		if (oParameterBase!=null)
		{
			var oParameterArray=oParameterBase.getChildren();
			if (oParameterArray!=null)
			{	
				for (var iIndex=0;iIndex<oParameterArray.length;iIndex++)
				{
					var iNodeName=parseInt(oParameterArray[iIndex].getName(),10);
					if (idValue<=iNodeName)
						idValue=iNodeName+1;
				}
			}
		}		
	}
	
	var baseNode = Property.getNode('values');
	try {
		if (baseNode!=null)
		    baseNode.removeChild(""+idValue);
	}
	catch (e){}
	
	storeSubParameter( idValue + '/name', Utf8.encode(unescape(oParameterObject.name)));
	storeSubParameter( idValue + '/id', idValue);
	if (oParameterObject.defaultFooter==null)
		storeSubParameter( idValue + '/defaultFooter', false);
	else
		storeSubParameter( idValue + '/defaultFooter', oParameterObject.defaultFooter);
	storeSubParameter( idValue + '/message/messageType', oParameterObject.message.messageType);
	if (oParameterObject.message.messageType=="email") {
		storeSubParameter( idValue + '/message/receiver', oParameterObject.message.receiver);
		storeSubParameter( idValue + '/message/subject', Utf8.encode(unescape(oParameterObject.message.subject)));
		storeSubParameter( idValue + '/message/messageBody', Utf8.encode(unescape(oParameterObject.message.message)));
	}
	for (var iIndex=0;iIndex<oParameterObject.triggers.length;iIndex++)
	{
		var sSubpath=idValue + '/triggers/' + (iIndex + 1) + "/";		
		storeSubParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type);
		switch(oParameterObject.triggers[iIndex].type) {
			case 'zone-scene':
				storeSubParameter(sSubpath + "zone" , oParameterObject.triggers[iIndex].zone);
				storeSubParameter(sSubpath + "group" , oParameterObject.triggers[iIndex].group);
				storeSubParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene);
				storeSubParameter(sSubpath + "dsid" , -1);
				break;
			case 'device-msg':
				storeSubParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid);
				storeSubParameter(sSubpath + "msg" , oParameterObject.triggers[iIndex].msg);
				break
			case 'device-scene':
				storeSubParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid);
				storeSubParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene);
                if (oParameterObject.triggers[iIndex].buttonIndex!=null)
                    storeSubParameter(sSubpath + "buttonIndex" , oParameterObject.triggers[iIndex].buttonIndex);
				break;
			case 'custom-event':
				storeSubParameter(sSubpath + "event" , oParameterObject.triggers[iIndex].event);
				break;
            case 'device-sensor':
                storeSubParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid);
                storeSubParameter(sSubpath + "eventid" , oParameterObject.triggers[iIndex].eventid);
                break;
		}
	}
    Property.store();
    updateTriggerRegistration(Property.getNode('values/' + idValue));
}

function updateTriggerRegistration(oChildNode){
    var oParameter={actions:'execute'};
    lInfo.logln("EM-Config Set Trigger " + oChildNode.getPath());
    registerTrigger(oChildNode.getPath(),'event-mailer',oParameter)    
}

function updateAllTrigger() {
    Property.load();
    var baseNode = Property.getNode('values');
    if (baseNode == null) {
        lInfo.logln("EM-Config update all trigger : no entries");     
        return;
    }
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        lInfo.logln("EM-Config Set Trigger" + iIndex);     
        var oChildNode = oArrayNode[iIndex];
        updateTriggerRegistration(oChildNode);
    }
}

if (raisedEvent.name == 'event-mailer') {
	lInfo.logln("event-mailer param action " + raisedEvent.parameter.actions);
	if (raisedEvent.parameter.actions=='save')
	{
	    lInfo.logln("event-mailer param value " + raisedEvent.parameter.value);		
		storeValue(raisedEvent.parameter.value);
		Property.store();
		var evt = new Event("event-mailer-saved",{});			
		evt.raise();
	}
	if (raisedEvent.parameter.actions=='enable')
	{
	    lInfo.logln("event-mailer enable value " + raisedEvent.parameter.id);	
	    
        var sanityCheck = Property.getNode('values/' + raisedEvent.parameter.id);
        if (sanityCheck != null) {                
    	    storeSubParameter(raisedEvent.parameter.id + '/conditions/enabled', true);
    		Property.store();
        }
        
		var evt = new Event("event-mailer-saved",{});			
		evt.raise();
	}
	if (raisedEvent.parameter.actions=='disable')
	{
	    lInfo.logln("event-mailer disable value " + raisedEvent.parameter.id);		

	    var sanityCheck = Property.getNode('values/' + raisedEvent.parameter.id);
        if (sanityCheck != null) {
    	    storeSubParameter(raisedEvent.parameter.id + '/conditions/enabled', false);
    		Property.store();
        }
		
        var evt = new Event("event-mailer-saved",{});			
		evt.raise();
	}	
	if (raisedEvent.parameter.actions=='delete')
	{
	    lInfo.logln("event-mailer delete value " + raisedEvent.parameter.id);		
		
		var baseNode = Property.getNode('values');
		if (baseNode!=null)
			baseNode.removeChild( raisedEvent.parameter.id);
		
		unregisterTrigger(baseNode.getPath()+"/" + raisedEvent.parameter.id);
		
		Property.store();
		var evt = new Event("event-mailer-saved",{});			
		evt.raise();
	}		
    if (raisedEvent.parameter.actions == 'updateTrigger') {
        lInfo.logln("EM-Config updateTrigger");     
        updateAllTrigger();
    }
} else if (raisedEvent.name == 'running') {
	Property.load();
	checkAndUpdateData();
	updateAllTrigger();
}
